/*____________________________________________________________________________*\
 *

 Copyright (c) 1997-2003 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/EnhPi3/Wizard.cpp,v $
 * $Date: 2003/05/13 18:41:59 $
 *
 Description:

\*____________________________________________________________________________*/
/* $SourceTop:$ */

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <assert.h>

#include "resrc1.h"
#include "Dialogs.h"
#include "Config.h"

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
static void Internal_centerPropertySheet( HWND hWnd )
{
    HWND hProp = ::GetParent( hWnd );
    if ( hProp )
        {
        /*
        ** Center window
        */
        RECT rDesktop;
        RECT rProp;
        
        ::GetWindowRect( ::GetDesktopWindow(), &rDesktop );
        ::GetWindowRect( hProp, &rProp );

        /*
        ** Calculate centered coordinates for property
        ** window
        */
        LONG lMiddleX = ( ( rDesktop.right - rDesktop.left ) /2 )
            + rDesktop.left;
        LONG lMiddleY = ( ( rDesktop.bottom - rDesktop.top ) /2 )
            + rDesktop.top;
        LONG lWidth = rProp.right - rProp.left;
        LONG lHeight = rProp.bottom - rProp.top;

        /*
        ** Move window
        */
        ::MoveWindow( hProp,
            lMiddleX - ( lWidth / 2 ),
            lMiddleY - ( lHeight / 2 ),
            lWidth,
            lHeight,
            TRUE );
        };
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
static BOOL CALLBACK DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam,
	LPARAM lParam)
{
	switch (uMsg)
		{
		case WM_INITDIALOG:
            Internal_centerPropertySheet( hDlg );
			break;

		case WM_NOTIFY:
			switch( ((NMHDR *)lParam)->code )
				{
				case PSN_QUERYCANCEL:
					return AD_cancelSetup( hDlg );

				case PSN_SETACTIVE:
					PropSheet_SetWizButtons( GetParent( hDlg ), PSWIZB_NEXT );
					break;

				case PSN_KILLACTIVE:
					break;

				case PSN_APPLY:
					break;

				};
			break;

		default:
				return (FALSE);
		};

	return (TRUE);
}

/*____________________________________________________________________________*\
 *
 Description:
	Definitions and global values
\*____________________________________________________________________________*/
DLGPROC fnStartWizard = (DLGPROC)DialogProc;
