/*____________________________________________________________________________*\
 *

 Copyright (c) 1997-2003 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission. 

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/Intrface/MIMEType.cpp,v $
 * $Date: 2003/05/13 18:42:06 $
 *
 Description:

\*____________________________________________________________________________*/
//$SourceTop:$

#include <iostream.h>
#include <stdio.h>
#include <windowsx.h>

#include "IFaceBse.h"
#include "PIStrStr.h"
#include "StrToken.h"

#include "QConfig.h"
#include "MIMEType.hrc"

/*
** #define D { cerr << __FILE__ << ": " << __LINE__ << endl; }
*/
#define D { cerr << __FILE__ << ": " << __LINE__ << endl; }
// #define D

/*____________________________________________________________________________*\
 *
 Description:
\*____________________________________________________________________________*/
#define C_RESOURCENAME                    "MIMETypesPage"

/*____________________________________________________________________________*\
 *
 Description:
\*____________________________________________________________________________*/
#if 0
	/*
	** HTML documentation for this handler
	*/
/*___+++HTMLDOC_BEGIN+++___*/
Name:
    MIMETypesPage

Description:
    Creates the eponymous property page and is used by the PropSheet object.

Example:
	<PRE>
	&lt;Object&gt;
		Name MIMETypesPage
		Class MIMETypesPageClass
		PropertyPage MIMETypesPage
	&lt;/Object&gt;

	</PRE>

/*___+++HTMLDOC_END+++___*/
#endif

/*____________________________________________________________________________*\
 *
 Description:
\*____________________________________________________________________________*/
static BOOL CALLBACK fnDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam,
    LPARAM lParam);

static const char *__pMIMETypes[] =
{
"xls\tapplication/msexcel",
"xlt\tapplication/msexcel",
"doc\tapplication/msword",
"bin\tapplication/octet-stream", 
"dms\tapplication/octet-stream", 
"lha\tapplication/octet-stream",
"lzh\tapplication/octet-stream",
"exe\tapplication/octet-stream",
"class\tapplication/octet-stream",
"oda\tapplication/oda",
"pdf\tapplication/pdf",
"ai\tapplication/postscript",
"eps\tapplication/postscript",
"ps\tapplication/postscript",
"ppt\tapplication/powerpoint",
"rtf\tapplication/rtf",
"bcpio\tapplication/x-bcpio",
"vcd\tapplication/x-cdlink",
"cpio\tapplication/x-cpio",
"csh\tapplication/x-csh",
"dcr\tapplication/x-director", 
"dir\tapplication/x-director", 
"dxr\tapplication/x-director",
"dvi\tapplication/x-dvi",
"gtar\tapplication/x-gtar",
"gz\tapplication/x-gzip", 
"hdf\tapplication/x-hdf",
"skp\tapplication/x-koan",
"skd\tapplication/x-koan",
"skt\tapplication/x-koan",
"skm\tapplication/x-koan",
"latex\tapplication/x-latex",
"mif\tapplication/x-mif",
"nc\tapplication/x-netcdf",
"cdf\tapplication/x-netcdf",
"sh\tapplication/x-sh",
"shar\tapplication/x-shar",
"sit\tapplication/x-stuffit",
"sv4cpio\tapplication/x-sv4cpio",
"sv4crc\tapplication/x-sv4crc",
"tar\tapplication/x-tar",
"tcl\tapplication/x-tcl",
"tex\tapplication/x-tex",
"texinfo\tapplication/x-texinfo",
"texi\tapplication/x-texinfo",
"t\tapplication/x-troff",
"troff\tapplication/x-troff",
"man\tapplication/x-troff-man",
"me\tapplication/x-troff-me",
"ms\tapplication/x-troff-ms",
"ustar\tapplication/x-ustar",
"uu\tapplication/x-uuencoded",
"src\tapplication/x-wais-source",
"zip\tapplication/zip",
"au\taudio/basic",
"snd\taudio/basic",
"mid\taudio/midi",
"midi\taudio/midi",
"kar\taudio/midi",
"mpga\taudio/mpeg",
"mp2\taudio/mpeg",
"aif\taudio/x-aiff",
"aiff\taudio/x-aiff",
"aifc\taudio/x-aiff",
"ram\taudio/x-pn-realaudio",
"rpm\taudio/x-pn-realaudio-plugin",
"ra\taudio/x-realaudio",
"wav\taudio/x-wav",
"pdb\tchemical/x-pdb",
"xyz\tchemical/x-pdb",
"gif\timage/gif",
"ief\timage/ief",
"jpeg\timage/jpeg",
"jpg\timage/jpeg",
"jpe\timage/jpeg",
"png\timage/png",
"tif\timage/tiff",
"tiff\timage/tiff",
"bmp\timage/x-MS-bmp",
"dip\timage/x-MS-bmp",
"ras\timage/x-cmu-raster",
"pnm\timage/x-portable-anymap",
"pbm\timage/x-portable-bitmap",
"pgm\timage/x-portable-graymap",
"ppm\timage/x-portable-pixmap",
"rgb\timage/x-rgb",
"xbm\timage/x-xbitmap",
"xpm\timage/x-xpixmap",
"xwd\timage/x-xwindowdump",
"htm\ttext/html",
"html\ttext/html",
"txt\ttext/plain",
"pi3\ttext/plain",
"rtx\ttext/richtext",
"tsv\ttext/tab-separated-values",
"etx\ttext/x-setext",
"sgm\ttext/x-sgml",
"sgml\ttext/x-sgml",
"c\ttext/x-code",
"cpp\ttext/x-code",
"cxx\ttext/x-code",
"cc\ttext/x-code",
"pm\ttext/x-perl",
"pl\ttext/x-perl",
"mpg\tvideo/mpeg",
"mpeg\tvideo/mpeg",
"mpe\tvideo/mpeg",
"mov\tvideo/quicktime",
"qt\tvideo/quicktime",
"avi\tvideo/x-msvideo",
"movie\tvideo/x-sgi-movie",
"ice\tx-conference/x-cooltalk",
"vrml\tx-world/x-vrml",
"wrl\tx-world/x-vrml",
"shtml\tinternal/x-server-parsed-html",
"html-ssi\tinternal/x-server-parsed-html",
"ssi\tinternal/x-server-parsed-html",
"fcgi\tinternal/x-fastcgi",
"map\tinternal/x-imagemap",
"imap\tinternal/x-imagemap",
"php\tinternal/x-server-parsed-php",
"php3\tinternal/x-server-parsed-php",
"php4\tinternal/x-server-parsed-php",
"psp\tinternal/x-server-parsed-psp",
"ppsp\tinternal/x-server-parsed-psp",
"jsp\tinternal/x-server-parsed-jsp",
"asp\tinternal/x-server-parsed-asp",
"cfm\tinternal/x-server-parsed-cfm",
"xml\tinternal/x-server-parsed-xml",

/* --- leave this last --- */
0
};

/*____________________________________________________________________________*\
 *
 Class:
 Description:
\*____________________________________________________________________________*/
class MIMETypesPage : public IFaceBase
{
private:
    QConfig *pConfig;
    PROPSHEETPAGE tPsp;
    Interface *pInterface;

    /*
    ** window private values
    */
    HWND hDlg;
    HWND hWndList;
    HWND hWndFileExt;
    HWND hWndMime;
    HWND hWndAdd;
    HWND hWndReplace;
    HWND hWndDelete;
    HWND hWndDefMime;
    DblList lExtensions;
    DblList lMIMEs;

	int Parameter( const char *pVariable, const char *pValue,
		const char *pWhere )
		{
		assert( pVariable && pValue );

		PIOStrStream os;

		os << pWhere << "MIMETypesPage: ";

        if ( 0 )
            {
            }
		else
			{
			os << "Unknown directive '" << pVariable <<
				"'" << ends;
			CONFIG_ERR( Object(), os.str() );
			return 0;
			};

		return 1;
		};

public:
	MIMETypesPage( PIObject *pObject, int iArgc, const char *ppArgv[] )
	:	IFaceBase( pObject ),
        pConfig( FindParentQConfig( PIObject_getDB( pObject ) ) ),
        hWndList( 0 ),
        hWndFileExt( 0 ),
        hWndMime( 0 ),
        hWndAdd( 0 ),
        hWndReplace( 0 ),
        hWndDelete( 0 ),
        pInterface( 0 ),
        hWndDefMime( 0 )
		{
        /*
        ** Read input parameters
        */
		ReadParameters( iArgc, ppArgv );

        if ( !IsOK() )
            { return; };

        /*
        ** Setup the PROPSHEETPAGE
        */
        memset( &tPsp, 0, sizeof( PROPSHEETPAGE ) );
        tPsp.dwSize = sizeof( PROPSHEETPAGE );
        tPsp.dwFlags = PSP_DEFAULT;
        tPsp.hInstance = (HINSTANCE)PIDLL_getSystemHandle( PIClass_getLibrary(
            PIObject_getClass( Object() ) ) );

        /* Status page */
        tPsp.pszTemplate = C_RESOURCENAME;
        tPsp.pfnDlgProc = (DLGPROC)fnDialogProc;
        tPsp.lParam = (LPARAM)this;

        /*
        ** Set the data DB of this object
        */
        PIDB *pDB = PIObject_getDB( Object() );
        PIDB_add( pDB, PIDBTYPE_OPAQUE, INTRFACE_WINDOWTYPE,
            (void *)INTRFACE_PROPPAGE, 0 );
        PIDB_add( pDB, PIDBTYPE_OPAQUE, INTRFACE_PROPSHEETPAGE,
            (void *)&tPsp, 0 );
        
        /*
        ** Done
        */
		};

	~MIMETypesPage()
		{
		};

    virtual int Handle( Interface &tWindow )
        {
        switch( tWindow.iMessage )
            {
            case INTRFACE_MSG_INIT:
                pInterface = &tWindow;
                break;

            case INTRFACE_MSG_WIN32CREATE:
                return Win32Create( tWindow );

            case INTRFACE_MSG_LOAD:
                return PIAPI_ABORT;

            case INTRFACE_MSG_DEFAULTS:
                {
                /*
                ** Add default MIME types
                */
                for( int i=0; __pMIMETypes[i]; i++ )
                    {
                    M_AddValue( pConfig, "MIMETypes", "Mapping",
                        __pMIMETypes[i] );
                    };
                };
                break;

            default:
                assert( 0 );
                return PIAPI_ABORT;
            };

        return PIAPI_COMPLETED;
        };

    int Win32Create( Interface &tWindow )
		{
        /* --- property sheet pages should not be created --- */
        return PIAPI_ABORT;
		};

    BOOL Internal_save()
        {
        enum { BUF_SIZE=1023 };
        char szBuf[BUF_SIZE+1];

        int i;
        int iCount = ::SendMessage( hWndList, LB_GETCOUNT, 0, 0 );
	
        /*
        ** Save all mime types
        */
        /* --- remove old ones first --- */
        M_DeleteValue( pConfig, "MIMETypes", "Mapping" );
        for( i=0; i<iCount; i++ )
            {
            *szBuf = '\0';
            szBuf[BUF_SIZE] = '\0';

            /*
            ** safety only
            */
            if ( ::SendMessage( hWndList, LB_GETTEXTLEN, 0, 0 )
                >= BUF_SIZE )
                {
                ::MessageBox( hDlg, "MIMEType too long",
                    "Internal Error", MB_OK );
                ::SetWindowLong( hDlg, DWL_MSGRESULT,
                    PSNRET_INVALID_NOCHANGEPAGE );
                break;
                };
            ::SendMessage( hWndList, LB_GETTEXT, i, (LPARAM)szBuf );
                M_AddValue( pConfig, "MIMETypes", "Mapping", szBuf );
			};

		/*
		** Save default mime type
		*/
		*szBuf = 0;
		SendMessage( hWndDefMime, WM_GETTEXT, BUF_SIZE, (LPARAM)szBuf );
		M_ReplaceValue( pConfig, "Internal", "DefaultMIMEType", szBuf );

        ::SetWindowLong( hDlg, DWL_MSGRESULT, FALSE );
        return (TRUE);
		};

    void Internal_addLine( const char *pLine )
        {
        assert( pLine );
        assert( lExtensions.Size()==lMIMEs.Size() );

        int i;
        for( i=0; pLine[i] && !isspace(pLine[i]); i++ );
	
        /* --- scan to tab --- */
        lExtensions.Append( (DblList::type)PI_NEW( PIString( pLine, i ) ) );

        /* --- scan over whitespace to start of Media type/subtype --- */
        for( ; pLine[i] && isspace(pLine[i]); i++ );
        lMIMEs.Append( (DblList::type)PI_NEW( PIString( &(pLine[i]) ) ) );	

        assert( lExtensions.Size()==lMIMEs.Size() );
        };

    void Internal_clearArrays()
        {
        DblListIterator x( lExtensions );
        DblListIterator y( lMIMEs );
        for( ; !x.BadIndex(); x++, y++ )
            {
            assert( !x.BadIndex() && !y.BadIndex() );
            PI_DELETE( (PIString *)x.Current() );
            PI_DELETE( (PIString *)y.Current() );
            };
        lExtensions.Clear();
        lMIMEs.Clear();
        };

    void Internal_reloadArrays()
        {
        enum { BUF_SIZE=1023 };
        char szBuf[BUF_SIZE+1];

        Internal_clearArrays();

        /*
        ** Get number of items
        */
        int iCount = ::SendMessage( hWndList, LB_GETCOUNT, 0, 0 );

        /* 
        ** Insert from listbox into internal arrays
        */
        int i;
        for( i=0; i<iCount; i++ )
            {
            ::SendMessage( hWndList, LB_GETTEXT, i, (LPARAM)szBuf );
            Internal_addLine( szBuf );
            };
        };

    void Internal_updateButtons( WPARAM wParam, LPARAM lParam, HWND hWndEdit1, 
        HWND hWndEdit2, const char *pExtension )
        {
        if ( GET_WM_COMMAND_CMD(wParam, lParam)!=EN_CHANGE )
            { return; };

        /*
        ** If the file extension changed then check if this is an existing
        ** file extension
        */
        int iExistingIndex = -1;
        assert( pExtension );
        int iChangeToIndex = -1;
        int iIndex = 0;
        if ( *pExtension )
            {
            for( DblListIterator i( lExtensions ); !i.BadIndex();
                i++, iIndex++ )
                {
                PIString *pString = (PIString *)i.Current();
                assert( pString );
                if ( !PIUtil_strncmpi( (*pString), pExtension,
                    strlen( pExtension ) ) )
                    {
                    iChangeToIndex = iIndex;

                    /*
                    ** If this is a full index, select it
                    */
                    if ( !stricmp( (*pString), pExtension ) )
                        { iExistingIndex = iIndex; };
                    break;
                    };
                };
            };

        /*
        ** Remove listbox selection or scroll to correct line
        ** as appropriate 
        */
        ::SendMessage( hWndList, LB_SETCURSEL, iChangeToIndex, 0 );

        /*
        ** Set buttons
        */
        if ( SendMessage( hWndEdit1, EM_LINELENGTH, 0, 0 )==0 )
            {
            if ( IsWindowEnabled( hWndAdd ) ) EnableWindow( hWndAdd, FALSE );
            if ( IsWindowEnabled( hWndReplace ) )
                ::EnableWindow( hWndReplace, FALSE );
            }
        else if ( SendMessage( hWndEdit2, EM_LINELENGTH, 0, 0 )!=0 )
            {
            if ( iExistingIndex>-1 )/* --- disable add, enable replace --- */
                {
                if ( IsWindowEnabled( hWndAdd ) )
                    ::EnableWindow( hWndAdd, FALSE );
                if ( !IsWindowEnabled( hWndReplace ) )
                    ::EnableWindow( hWndReplace, TRUE );
			    }
		    else        /* --- disable replace, enable add --- */
			    {
			    if ( !IsWindowEnabled( hWndAdd ) )
                    ::EnableWindow( hWndAdd, TRUE );
			    if ( IsWindowEnabled( hWndReplace ) )
                    ::EnableWindow( hWndReplace, FALSE );
                };
            };

        /*
        ** If there is a selected item in the listbox then
        ** enable delete, otherwise disable delete	
        */
        if ( SendMessage( hWndList, LB_GETCURSEL, 0, 0 )==LB_ERR )
            { EnableWindow( hWndDelete, FALSE ); }
        else
            { EnableWindow( hWndDelete, TRUE ); };
        };

    BOOL DialogProc(HWND hTheDlg, UINT uMsg, WPARAM wParam,
	LPARAM lParam)
        {
		enum { BUF_SIZE=1023 };
		char szBuf[BUF_SIZE+1];
		int aTabstop[2];
	
		switch (uMsg)
			{
			case WM_INITDIALOG:
                hDlg = hTheDlg;
				HourglassOn();
				{
				const char *pTmp;
				int iTmp;
				hWndList = GetDlgItem( hDlg, IDC_LIST );
				hWndFileExt = GetDlgItem( hDlg, IDC_FILEEXT );
				hWndMime= GetDlgItem( hDlg, IDC_MIME );
				hWndAdd = GetDlgItem( hDlg, IDC_ADD );
				hWndReplace = GetDlgItem( hDlg, IDC_REPLACE );
				hWndDelete = GetDlgItem( hDlg, IDC_DELETE );
				hWndDefMime = GetDlgItem( hDlg, IDC_DEFMIME );
	
				assert( hWndList && hWndFileExt && hWndMime );
				assert( hWndAdd && hWndReplace && hWndDelete );
				assert( hWndDefMime );
				
				EnableWindow( hWndAdd, FALSE );
				EnableWindow( hWndReplace, FALSE );
				EnableWindow( hWndDelete, FALSE );
	
				/*
				** Limit edit field lengths, really just a sanity thing
				*/
				SendMessage( hWndFileExt, EM_SETLIMITTEXT, 256, 0 );
				SendMessage( hWndMime, EM_SETLIMITTEXT, 256, 0 );
				SendMessage( hWndDefMime, EM_SETLIMITTEXT, 256, 0 );
				
				/*
				** Setup tabstops
				*/
				aTabstop[0] = 0;
				aTabstop[1] = 75;
				SendMessage( hWndList, LB_SETTABSTOPS, 2, (LPARAM)&aTabstop );
	
				/*
				** Load all mime types into list box
				*/
				iTmp = 0;
				for(;; iTmp++ )
					{
					pTmp = M_LookupValueEx( pConfig, "MIMETypes", 
						"Mapping", iTmp );
					if ( !pTmp )
						{ break; };
	
					SendMessage( hWndList, LB_ADDSTRING, 0, (LPARAM)pTmp );
					};
				Internal_reloadArrays();
				}

				/*
				** Load default mime type
				*/
				SendMessage( hWndDefMime, WM_SETTEXT, 0,
					(LPARAM)M_LookupValue( pConfig, "Internal", "DefaultMIMEType" ));
				HourglassOff();
				break;
	
			case WM_DESTROY:
				Internal_clearArrays();
				break;
	
			case WM_COMMAND:
				switch (GET_WM_COMMAND_ID(wParam, lParam))
					{
					case IDC_ADD:
						{
						int i;
						*szBuf = '\0';
						SendMessage( hWndFileExt, WM_GETTEXT, BUF_SIZE,
                            (LPARAM)szBuf );
						for( i=0; i<BUF_SIZE && szBuf[i] && !isspace( szBuf[i] ); i++ );
						if ( szBuf[i] ) { szBuf[i] = '\0'; };
						lExtensions.Append( (DblList::type)PI_NEW( PIString( szBuf ) ) );
						szBuf[i++] = '\t';
						SendMessage( hWndMime, WM_GETTEXT, BUF_SIZE-i, (LPARAM)&(szBuf[i]) );
						lMIMEs.Append( (DblList::type)PI_NEW( PIString( &(szBuf[i]) ) ) );
						SendMessage( hWndList, LB_ADDSTRING, 0, (LPARAM)szBuf );
	
						/*
						** Clear edit fields, focus to list
						*/
						SendMessage( hWndFileExt, WM_SETTEXT, 0, (LPARAM)"" );
						SendMessage( hWndMime, WM_SETTEXT, 0, (LPARAM)"" );
						Internal_reloadArrays();
						int iIndex = SendMessage( hWndList, LB_FINDSTRINGEXACT, 0, (LPARAM)szBuf );
						if ( iIndex!=LB_ERR ) SendMessage( hWndList, LB_SETTOPINDEX, iIndex, 0 );
						SetFocus( hWndList );
						Changed( hDlg );
						};
						break;
		
					case IDC_REPLACE:
						{
						/*
						** Get selected item index 
						*/
						int iCurSel = SendMessage( hWndList, LB_GETCURSEL, 0, 0 );
	
						/*
						** Get text to add and add it to internal lists only
						*/
						int i;
						*szBuf = '\0';
						SendMessage( hWndFileExt, WM_GETTEXT, BUF_SIZE, (LPARAM)szBuf );
						for( i=0; i<BUF_SIZE && szBuf[i] && !isspace( szBuf[i] ); i++ );
						if ( szBuf[i] ) { szBuf[i] = '\0'; };
						lExtensions.Append( (DblList::type)PI_NEW( PIString( szBuf ) ) );
						szBuf[i++] = '\t';
						SendMessage( hWndMime, WM_GETTEXT, BUF_SIZE-i, (LPARAM)&(szBuf[i]) );
						lMIMEs.Append( (DblList::type)PI_NEW( PIString( &(szBuf[i]) ) ) );
		
						/*
						** Delete the item from the list and internal lists
						*/
						SendMessage( hWndList, LB_DELETESTRING,	iCurSel, 0 );
						PI_DELETE( (PIString *)lExtensions.Detach( iCurSel) );
						PI_DELETE( (PIString *)lMIMEs.Detach( iCurSel) );
						
						/*
						** Add new item to listbox
						*/
						SendMessage( hWndList, LB_ADDSTRING, 0, (LPARAM)szBuf );
	
						/*
						** Clear edit fields, focus to list
						*/
						SendMessage( hWndFileExt, WM_SETTEXT, 0, (LPARAM)"" );
						SendMessage( hWndMime, WM_SETTEXT, 0, (LPARAM)"" );
						Internal_reloadArrays();
						int iIndex = SendMessage( hWndList, LB_FINDSTRINGEXACT, 0, (LPARAM)szBuf );
						if ( iIndex!=LB_ERR ) SendMessage( hWndList, LB_SETTOPINDEX, iIndex, 0 );
						SetFocus( hWndList );
						Changed( hDlg );
						};
						break;
	
					case IDC_DELETE:
						{
						int iCurSel = SendMessage( hWndList, LB_GETCURSEL, 0, 0 );
						SendMessage( hWndList, LB_DELETESTRING,	iCurSel, 0 );
						PI_DELETE( (PIString *)lExtensions.Detach( iCurSel) );
						PI_DELETE( (PIString *)lMIMEs.Detach( iCurSel) );
				
						/*
						** Clear edit fields, focus to list
						*/
						SendMessage( hWndFileExt, WM_SETTEXT, 0, (LPARAM)"" );
						SendMessage( hWndMime, WM_SETTEXT, 0, (LPARAM)"" );
						SetFocus( hWndList );
						Changed( hDlg );
						};
						break;
	
					case IDC_FILEEXT:
						*szBuf = '\0';
						SendMessage( hWndFileExt, WM_GETTEXT, BUF_SIZE, (LPARAM)szBuf ); 
						Internal_updateButtons( wParam, lParam, hWndFileExt, 
							hWndMime, szBuf );
						break;
	
					case IDC_MIME:
						*szBuf = '\0';
						SendMessage( hWndFileExt, WM_GETTEXT, BUF_SIZE,(LPARAM)szBuf );
						Internal_updateButtons( wParam, lParam, hWndMime, 
							hWndFileExt, szBuf );
						break;
	
					case IDC_LIST:
						if ( GET_WM_COMMAND_CMD(wParam, lParam)==LBN_SELCHANGE )
							{
							int iSel = SendMessage( hWndList, LB_GETCURSEL, 0, 0 );
							if ( iSel!=LB_ERR )
								{
								assert( iSel>=0 && iSel<lExtensions.Size() );
								EnableWindow( hWndDelete, TRUE );
								SendMessage( hWndFileExt, WM_SETTEXT, 0,
									(LPARAM)(const char *)*((PIString *)lExtensions[iSel]) );
								SendMessage( hWndMime, WM_SETTEXT, 0,
									(LPARAM)(const char *)*((PIString *)lMIMEs[iSel]) );
								};
							};
						break;

					case IDC_DEFMIME:
						if ( GET_WM_COMMAND_CMD(wParam, lParam)==EN_CHANGE )
						Changed( hDlg );
						break;
	
					default:;		
					}
				break;

			case WM_NOTIFY:
				switch( ((NMHDR *)lParam)->code )
					{
					case PSN_QUERYCANCEL:
						return SHEET->Cancel(pInterface, hDlg);
	
					case PSN_KILLACTIVE:
                        return Internal_save();
	
					default:
		                return (FALSE);
					};
				break;
	
			default:
                return (FALSE);
			};

		return (TRUE);
		};

};

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
static BOOL CALLBACK fnDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam,
    LPARAM lParam)
{
    if ( uMsg==WM_INITDIALOG )
        {
        ::SetWindowLong( hDlg, DWL_USER, ((LPPROPSHEETPAGE)lParam)->lParam );
        };

    MIMETypesPage *pPage = (MIMETypesPage *)::GetWindowLong( hDlg, DWL_USER );
    return pPage ? pPage->DialogProc( hDlg, uMsg, wParam, lParam ) : FALSE;
}

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int MIMETypesPage_constructor( PIObject *pObj,
	int iArgc, const char *ppArgv[] )
{
	return IFaceBase_constructor( pObj, PI_NEW( MIMETypesPage( pObj,
		iArgc, ppArgv ) ) );
}

#if 0
/*___+++CNF_BEGIN+++___*/
	<Class>
		Name MIMETypesPageClass
		Type LogicExtension
		Library IntrFace
		OnClassLoad IFaceBase_onClassLoad
		Constructor MIMETypesPage_constructor
		CopyConstructor IFaceBase_copyConstructor
		Destructor IFaceBase_destructor
		Execute IFaceBase_execute
	</Class>

	<Object>
		Name MIMETypesPage
		Class MIMETypesPageClass
	</Object>

/*___+++CNF_END+++___*/
#endif

