/*____________________________________________________________________________*\
 *

 Copyright (c) 1997-2003 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/Pi2API/Pi2API.h,v $
 * $Date: 2003/05/13 18:42:09 $
 *
 Description:
	Top level include file for PIAPI. Includes all header files
	necessary for using any facility in PIAPI.
\*____________________________________________________________________________*/
/* $HeaderTop:$ */

#ifndef PI2API_H_
#define PI2API_H_

#include "PiAPI.h"		/* OS API */

/*____________________________________________________________________________*\
 *
	All exported and imported shared objects have C linkage.
\*____________________________________________________________________________*/
#if !defined(PUBLIC_PIAPI)
#	if defined(__cplusplus)
#		define PUBLIC_PIAPI	extern "C" 
#	else
#		define PUBLIC_PIAPI
#	endif
#endif

/* ---
	API include files
--- */

/* --- using program database --- */
#include "PIDB.h"			/* program database */
#include "PIConfig.h"		/* configuration database */
#include "PIDBKeys.h"		/* keys for the program database */
#include "PILib.h"			/* dynamically loaded libraries */
#include "PIClass.h"		/* loadable classes */
#include "PIObject.h"		/* object instances */
#include "PIIO.h"			/* I/O Class */
#include "PILogic.h"		/* Logic Class */
#include "PIProg.h"			/* general program facilities */
#include "PILog.h"			/* logging facilities */

#endif	/* PI2API_H_ */

