/*____________________________________________________________________________*\
 *

 Copyright (c) 1997-2003 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/Platform/PIDefs.h,v $
 * $Date: 2003/05/13 18:42:14 $
 *
 Description:
	Defininition of error codes and macros for PI.
\*____________________________________________________________________________*/
/* $HeaderTop:$ */

#ifndef PIDEFS_H_
#define PIDEFS_H_

#define PIAPI_COMPLETED		(0)		/* action completed succesfully */
#define PIAPI_ERROR			(-1)	/* an unspecified local error occured */
#define PIAPI_EXHAUSTED		(-2)	/* a system or program resource allocation
										failed */
#define PIAPI_INTERNALERROR	(-3)	/* an internal error caused by a bug */ 
#define PIAPI_EINVAL		(-4)	/* an invalid argument was given */
#define PIAPI_NOTSUPPORTED	(-5)	/* unimplemented facility */
#define PIAPI_EEXIST		(-6)	/* cannot create new object because an
										object already exists */
#define PIAPI_EACCES		(-7)	/* access denied */
#define PIAPI_EINIT			(-8)	/* library not correctly initialized */
#define PIAPI_DEADLOCK		(-9)	/* action would cause deadlock */

/* ----
Specialized return codes
--- */
#define PIAPI_CONTINUE		(-1001)	/* no action performed */
#define PIAPI_WARNING		(-1002)	/* something to take note of */
#define PIAPI_ABORT			(-1003)	/* an unspecified critical error occurred */
#define PIAPI_TIMEOUT		(-1004)	/* a timeout occurred */

/* ---
Additional context dependant result codes
--- */
#define PIAPI_WOULDBLOCK	(-10)	/* for non-blocking socket operations */

/* ---
Special
--- */
#define PIAPI_TRUE			(1)	
#define PIAPI_FALSE			(0)	

/* ---
Thread priorities
--- */
#define PITHREAD_PRIORITY_SIZE		5
#define PITHREAD_PRIORITY_INVALID	-1
#define PITHREAD_PRIORITY_LOWEST	0
#define PITHREAD_PRIORITY_LOW		1
#define PITHREAD_PRIORITY_MED		2
#define PITHREAD_PRIORITY_HIGH		3
#define PITHREAD_PRIORITY_HIGHEST	4

/* ---
Thread flags
--- */
#define PITHREAD_FLAGS_SUSPENDED	0x0001

#endif	/* PIDEFS_H_ */

