/*____________________________________________________________________________*\
 *

 Copyright (c) 1997-2003 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission. 

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/Servlet/org/pi3/servlet/samples/ContextServlet.java,v $
 * $Date: 2003/05/13 18:42:21 $
 *
 Description:
	Utility class, providing some usefull methods.

\*____________________________________________________________________________*/

package org.pi3.servlet.samples;

import java.io.*;
import java.net.URL;
import java.net.MalformedURLException;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Enumeration;

public class ContextServlet extends HttpServlet {
  public void doGet( HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
      String s;
      response.setContentType("text/html; charset=utf-8");
      StringBuffer sb = new StringBuffer("<H1>Context Servlet</H1>\r\n");
	sb.append("<p>This servlet engine supports <b>Servlet API Version ");
      sb.append(getServletContext().getMajorVersion());
      sb.append(".");
	sb.append(getServletContext().getMinorVersion());
      sb.append("</b>.<HR>\r\n");
	sb.append("<H2>ServletContext Methods</H2>");
	sb.append("<p><b>getRealPath(\"/images/\"): </b>" + getServletContext().getRealPath("/images/"));
	sb.append("<p><b>getMimeType(\"/images/Pi3Tile.gif\"): </b>" + getServletContext().getMimeType("/images/Pi3Tile.gif"));
	sb.append("<p><b>getServerInfo(): </b>" + getServletContext().getServerInfo());
	sb.append("<H2>Including Ressources</H2><HR>\r\n");
	
      URL url;
      try {
        sb.append("<p><b>Invocing getServletContext().getRessource(\"/index.html\"): </b>");
	  sb.append("<p>");
        url = getServletContext().getResource("/index.html");
	} catch (MalformedURLException e) {
	  return;
	};

      int rd = 0;
      byte[] buf = new byte[1024];

      if (url != null) {
	  InputStream ins = url.openStream();
        while (ins.available() != 0) {
          rd = ins.read(buf);
          if (rd > 0) {
            s = new String(buf, 0, rd);
            sb.append(s);
          } else {
            break;
          };
        };
      };

      sb.append("<p><b>Invocing getServletContext().getRessourceAsStream(\"/index.html\"): </b>");
      InputStream ins = getServletContext().getResourceAsStream("/index.html");
      while (ins.available() != 0) {
        rd = ins.read(buf);
        if (rd > 0) {
          s = new String(buf, 0, rd);
          sb.append(s);
        } else {
          break;
        };
      };

	s = sb.toString();
      response.setContentLength(s.length());
      ServletOutputStream out = response.getOutputStream();
      out.print(s);
      out.flush();
    }
  }