
/*
 * Step6:
 * Deadlock detection.
 * Detect deadlock from suspension.
 */

#include <iostream.h>
#include <stdlib.h>

#include "PiAPI.h"
#include "TestOS.h"

int iRet;
void Step7()
{
	iRet = -1;

	/* ---
	Do deadlock by suspending the current thread. There is only one
	thread in this program
	--- */
	if (! ( PIThread_suspend( PIThread_getCurrent() )==PIAPI_ERROR &&
		PIPlatform_getLastError() == PIAPI_DEADLOCK ) )
		{ FAILED(1); return; };

	OK;
	iRet = 0;
}

int main()
{
	if ( PIPlatform_enter( "dummy", PIPLATFORM_VERSION_1_0, Step7 ) )
		{
		cout << "Platform_enter() failed." << endl;
		FAILED(99);
		exit( 1 );
		};

	return iRet;
}

